"use strict";
// Copyright 2024 IOTA Stiftung
// SPDX-License-Identifier: Apache-2.0
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CreateDelegationTransaction = exports.PreparedCreateDelegationTransactionData = exports.PreparedCreateDelegationTransaction = void 0;
const prepared_transaction_1 = require("./prepared-transaction");
const class_transformer_1 = require("class-transformer");
const transaction_1 = require("./transaction");
const prepared_transaction_data_1 = require("../client/prepared-transaction-data");
/*
 * Represents prepared data for issuing a transaction to create a delegation.
 */
class PreparedCreateDelegationTransaction extends prepared_transaction_1.PreparedTransaction {
    /**
     * @param preparedData Prepared data to create a delegation.
     * @param wallet A wallet.
     */
    constructor(preparedData, wallet) {
        super(preparedData.transaction, wallet);
        this._delegationId = preparedData.delegationId;
    }
    /**
     * The function returns the delegationId.
     *
     * @returns: The delegation id of the prepared transaction.
     */
    delegationId() {
        return this._delegationId;
    }
}
exports.PreparedCreateDelegationTransaction = PreparedCreateDelegationTransaction;
/** The result of preparing an operation to create a delegation. */
class PreparedCreateDelegationTransactionData {
}
__decorate([
    (0, class_transformer_1.Type)(() => prepared_transaction_data_1.PreparedTransactionData)
], PreparedCreateDelegationTransactionData.prototype, "transaction", void 0);
exports.PreparedCreateDelegationTransactionData = PreparedCreateDelegationTransactionData;
/** The result of an operation to create a delegation. */
class CreateDelegationTransaction {
}
__decorate([
    (0, class_transformer_1.Type)(() => transaction_1.TransactionWithMetadata)
], CreateDelegationTransaction.prototype, "transaction", void 0);
exports.CreateDelegationTransaction = CreateDelegationTransaction;
//# sourceMappingURL=create-delegation-transaction.js.map