import { AccountId } from '../block';
import { SignedTransactionPayload } from '../block/payload/signed_transaction';
import { InputSigningData } from '../client';
import { HexEncodedString, NumericString } from '../utils';
/** The signed transaction with inputs data */
export declare class SignedTransactionData {
    /** A signed transaction payload. */
    payload: SignedTransactionPayload;
    /** Signed inputs data. */
    inputsData: InputSigningData;
    /** Mana rewards by input. */
    manaRewards?: {
        [outputId: HexEncodedString]: NumericString;
    };
    /** The block issuer id from which the BIC for the block containing this transaction should be burned. */
    issuerId?: AccountId;
}
