import { SlotCommitmentId } from '../../block';
import { Output, OutputId } from '../../block/output';
/**
 * All UTXO changes that happened at a specific slot.
 */
export declare class UtxoChangesResponse {
    /**
     * The commitment ID of the requested slot that contains the changes.
     */
    commitmentId: SlotCommitmentId;
    /**
     * The created outputs of the given slot.
     */
    createdOutputs: OutputId[];
    /**
     * The consumed outputs of the given slot.
     */
    consumedOutputs: OutputId[];
}
/**
 * An output with its id.
 */
export declare class OutputWithId {
    /**
     * The output id.
     */
    outputId: OutputId;
    /**
     * The output.
     */
    output: Output;
}
/**
 * All full UTXO changes that happened at a specific slot.
 */
export declare class UtxoChangesFullResponse {
    /**
     * The commitment ID of the requested slot that contains the changes.
     */
    commitmentId: SlotCommitmentId;
    /**
     * The created outputs of the given slot.
     */
    createdOutputs: OutputWithId[];
    /**
     * The consumed outputs of the given slot.
     */
    consumedOutputs: OutputWithId[];
}
