// Copyright 2024 IOTA Stiftung
// SPDX-License-Identifier: Apache-2.0
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { PreparedTransaction } from './prepared-transaction';
import { Type } from 'class-transformer';
import { TransactionWithMetadata } from './transaction';
import { PreparedTransactionData } from '../client/prepared-transaction-data';
/*
 * The class PreparedCreateNativeTokenTransaction represents prepared data for issuing a transaction to create a native token.
 */
var PreparedCreateNativeTokenTransaction = /** @class */ (function (_super) {
    __extends(PreparedCreateNativeTokenTransaction, _super);
    /**
     * @param preparedData Prepared data to create a Native Token.
     * @param wallet A wallet.
     */
    function PreparedCreateNativeTokenTransaction(preparedData, wallet) {
        var _this = _super.call(this, preparedData.transaction, wallet) || this;
        _this._tokenId = preparedData.tokenId;
        return _this;
    }
    /**
     * The function returns the tokenId as a string.
     *
     * Returns:
     *
     * The token id of the CreateNativeTokenTransaction.
     */
    PreparedCreateNativeTokenTransaction.prototype.tokenId = function () {
        return this._tokenId;
    };
    return PreparedCreateNativeTokenTransaction;
}(PreparedTransaction));
export { PreparedCreateNativeTokenTransaction };
/** The result of preparing an operation to create a native token. */
var PreparedCreateNativeTokenTransactionData = /** @class */ (function () {
    function PreparedCreateNativeTokenTransactionData() {
    }
    __decorate([
        Type(function () { return PreparedTransactionData; })
    ], PreparedCreateNativeTokenTransactionData.prototype, "transaction");
    return PreparedCreateNativeTokenTransactionData;
}());
export { PreparedCreateNativeTokenTransactionData };
/** The result of an operation to create a native token. */
var CreateNativeTokenTransaction = /** @class */ (function () {
    function CreateNativeTokenTransaction() {
    }
    __decorate([
        Type(function () { return TransactionWithMetadata; })
    ], CreateNativeTokenTransaction.prototype, "transaction");
    return CreateNativeTokenTransaction;
}());
export { CreateNativeTokenTransaction };
//# sourceMappingURL=prepared-create-token-transaction.js.map