// Copyright 2023 IOTA Stiftung
// SPDX-License-Identifier: Apache-2.0
/**
 * All of the block payload types.
 */
var PayloadType;
(function (PayloadType) {
    /** A tagged data payload. */
    PayloadType[PayloadType["TaggedData"] = 0] = "TaggedData";
    /** A signed transaction payload. */
    PayloadType[PayloadType["SignedTransaction"] = 1] = "SignedTransaction";
    /** A candidacy announcement payload. */
    PayloadType[PayloadType["CandidacyAnnouncement"] = 2] = "CandidacyAnnouncement";
})(PayloadType || (PayloadType = {}));
/**
 * The base class for block payloads.
 */
var Payload = /** @class */ (function () {
    /**
     * @param type The type of payload.
     */
    function Payload(type) {
        this.type = type;
    }
    return Payload;
}());
export { PayloadType, Payload };
//# sourceMappingURL=payload.js.map